(function() {
	tpl.ui = {};
	
	//
	//Creates the detailed window for the test cases to be loaded
	//
	tpl.ui.createDetailWindow = function(_rowData)
	{
		var detailWindow = Ti.UI.createWindow({
			title:_rowData.title,
			backgroundColor: 'white'
		});
		var functName = "tpl.";
		
		if (_rowData.level == "smoke") {
			functName = functName + "st." + _rowData.title + "(detailWindow)";
		} else if (_rowData.level == "acceptance") {
			functName = functName + "at." + _rowData.title + "(detailWindow)";
		} else if (_rowData.level == "full") {
			functName = functName + "ft." + _rowData.title + "(detailWindow)";
		}
		
		detailWindow = eval(functName);
		return detailWindow;
	};
	
	//
	//Creates the TableView to display test for each of the window
	//
	tpl.ui.createTableView = function(_level) {
		var done = Titanium.UI.createButton({
					title:"Done",
					height: 50,
					width: 50,
					bottom: 0,
					right: 0
		});
		
		var tableView = Ti.UI.createTableView();
		
		if (_level == 'Smoke') {
			var smokeData = tpl.st.createData();
			tableView.setData(smokeData);
		} else if (_level == 'Acceptance') {
			var acceptanceData = tpl.at.createData();
			tableView.setData(acceptanceData);
		} else if(_level == 'Full') {
			var fullData = tpl.ft.createData();
			tableView.setData(fullData);
		}	
		tableView.addEventListener('click', function(_e) {
			var win = tpl.ui.createDetailWindow(_e.rowData);
			win.add(done);
			done.addEventListener('click', function() {
				win.close();
			});
			win.open();
		});
		return tableView;
	};
	
	//
	//Creates the windows for the tabs
	//
	tpl.ui.createWindow = function(_level) {
		var win = Titanium.UI.createWindow({
			title : _level,
			backgroundColor : 'white'
		});
		if(_level == 'About') {
			var data = '';
			data += 'ID: ' + Titanium.App.getID() + '\n';
			data += 'Name: ' + Titanium.App.getName() + '\n';
			data += 'Version: ' + Titanium.App.getVersion() + '\n';
			data += 'Publisher: ' + Titanium.App.getPublisher() + '\n';
			data += 'URL: ' + Titanium.App.getURL() + '\n';
			data += 'Description: ' + Titanium.App.getDescription() + '\n';
			data += 'Copyright: ' + Titanium.App.getCopyright() + '\n';
			data += 'GUID: ' + Titanium.App.getGUID() + '\n';
			data += 'Build: ' + Titanium.version + '.' + Titanium.buildHash + ' (' + Titanium.buildDate + ')\n';
			data += 'Display caps density:' + Titanium.Platform.displayCaps.density + '\n';
			data += 'Platform: ' + Titanium.Platform.name + '\n';
			data += 'Model: ' + Ti.Platform.model + '\n';
			data += 'OS Name: ' + Ti.Platform.osname;

			var label = Titanium.UI.createLabel({
				text : data,
				color: 'black',
				top : 10,
				textAlign : 'left',
				width : 'auto',
				height : 'auto'
			});
			win.add(label);
		}
		else{ 
			win.add(tpl.ui.createTableView(_level));
		}
		return win;
	};
	
	//
	//Creates the tab group for the smoke, acceptance, and full test cases
	//
	tpl.ui.createApplicationTabGroup = function() {
		var tabGroup = Titanium.UI.createTabGroup();

		var smoke = tpl.ui.createWindow('Smoke');
		var acceptance = tpl.ui.createWindow('Acceptance');
		var full = tpl.ui.createWindow('Full');
		var about = tpl.ui.createWindow('About');

		tpl.smokeTab = Titanium.UI.createTab({
			title : 'Smoke',
			window : smoke
		});

		tpl.acceptanceTab = Titanium.UI.createTab({
			title : 'Acceptance',
			window : acceptance
		});

		tpl.fullTab = Titanium.UI.createTab({
			title : 'Full',
			window : full
		});

		tpl.aboutTab = Titanium.UI.createTab({
			title : 'About',
			window : about
		});

		tabGroup.addTab(tpl.smokeTab);
		tabGroup.addTab(tpl.acceptanceTab);
		tabGroup.addTab(tpl.fullTab);
		tabGroup.addTab(tpl.aboutTab);

		return tabGroup;
	};
	
	tpl.ui.getSkipLabel = function() {
		var label = Ti.UI.createLabel({
			text:"Skip This Test"
		});

		return label;
	};
	
	
})();
